import protobuf from "protobufjs";
import Head from "next/head";
import Image from "next/image";
import { useEffect, useRef, useState } from "react";
import styles from "../styles/Home.module.css";
import useProtobufLoad from "../components/hooks/useProtobufLoad";
import protoFilePath from "../components/constants/protoFilePath";
import useProtobufGroupLoadCheck from "../components/hooks/useProtobufGroupLoadCheck";

export default function Home() {
  const socket = useRef();
  const websocketRequestPB = useProtobufLoad(
    protoFilePath.websocket.fileName,
    protoFilePath.websocket.path.websocketRequest
  );
  const websocketChannelPB = useProtobufLoad(
    protoFilePath.websocket.fileName,
    protoFilePath.websocket.path.websocketChannel
  );
  const websocketWrapMessageChannelPB = useProtobufLoad(
    protoFilePath.websocket.fileName,
    protoFilePath.websocket.path.websocketWrapMessageChannel
  );
  const runningTradePB = useProtobufLoad(
    protoFilePath.websocket.fileName,
    protoFilePath.websocket.path.runningTrade
  );

  const pbLoading = useProtobufGroupLoadCheck([
    websocketRequestPB,
    websocketChannelPB,
    websocketWrapMessageChannelPB,
    runningTradePB,
  ]);
  /** @type {{ current: WebSocket }}  */
  const data = useRef([]);
  const [, setForceUpdate] = useState({});

  const initSocket = () => {
    socket.current = new WebSocket("wss://wss-trading.lab.stockbit.com/ws");
    socket.current.binaryType = "arraybuffer";
  };

  const setSocketEvent = () => {
    if (!socket.current) return;

    socket.current.addEventListener("open", () => {
      console.log("Connected", socket);
    });
  };

  const stopChannelRequest = () => {
    const websocketChannel = websocketChannelPB.create({
      runningTrade: [],
    });

    const websocketRequest = websocketRequestPB.create({
      channel: websocketChannel,
    });

    const websocketRequestBuffer = websocketRequestPB
      .encode(websocketRequest)
      .finish();

    console.log("Stopping Ws Request...");
    console.log({ stopRequest: websocketRequest });

    console.log(websocketRequest);

    socket.current.send(websocketRequestBuffer);

    console.log({
      decodeSendMessage: websocketRequestPB.decode(websocketRequestBuffer),
    });
  };

  const createChannelRequest = () => {
    // const wsRequestMessage = websocketRequestPB.encode()
    const websocketChannel = websocketChannelPB.create({
      runningTrade: ["BBCA", "BBNI"],
    });

    const websocketRequest = websocketRequestPB.create({
      userId: "1234",
      key: "wsKey",
      channel: websocketChannel,
    });

    const websocketRequestBuffer = websocketRequestPB
      .encode(websocketRequest)
      .finish();
    console.log({ websocketRequestBuffer });

    socket.current.send(websocketRequestBuffer);
  };

  useEffect(() => {
    if (socket.current) return;
    initSocket();
    setSocketEvent();
  }, []);

  useEffect(() => {
    if (!pbLoading && socket.current) {
      socket.current.addEventListener("open", createChannelRequest);
      socket.current.addEventListener("message", (message) => {
        if (!window.websocketWrapMessageChannelPB)
          window.websocketWrapMessageChannelPB = websocketWrapMessageChannelPB;

        const { runningTrade } =
          websocketWrapMessageChannelPB.decode(new Uint8Array(message.data)) ||
          {};
        data.current = [runningTrade, ...data.current];
        setForceUpdate({});
      });
    }
  }, [pbLoading]);

  return (
    <div className={styles.container}>
      <Head>
        <title>Create Next App</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/favicon.ico" />
      </Head>
      <button onClick={stopChannelRequest}>Stop Request</button>
      <table>
        <tbody>
          {data.current.map(({ stock, volume, price }, i) => (
            <tr key={i.toString()}>
              <td>{stock}</td>
              <td>{volume}</td>
              <td>{price}</td>
            </tr>
          ))}
        </tbody>
      </table>
    </div>
  );
}
